/*
 * Copyright (C) 2020  Max Regan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include <cinttypes>
#include "printf.h"

#include "Bsp/Drivers/RtcDriver.h"

#include "TestBoard.h"
#include "test.h"

using BSP::ReturnCode;
using BSP::Time;
using BSP::time_t;

static void fail_if_wakeup(time_t delay) {
    uint32_t pre_wakeups = BSP::RtcDriver::get_wakeup_count();
    time_t before = Test::get_time();
    while (before + delay > Test::get_time() && BSP::RtcDriver::get_wakeup_count() == pre_wakeups) {}

    if (BSP::RtcDriver::get_wakeup_count() != pre_wakeups) {
        g_test_uart.tx_blocking("Got unexpected wakeup IRQ\r\n");
        g_test_uart.tx_blocking(test_fail_text);
        TEST_SPIN();
    }
}

[[noreturn]] void main() {

    board_init();

    g_test_uart.tx_blocking(test_start_text);

    for (uint32_t i = 0; i <= 100; i++) {
        Test::stop_for(Time::millis(5));
    }

    for (uint32_t delay_millis = 4; delay_millis <= 1024; delay_millis *= 2) {
        Test::stop_for(Time::millis(delay_millis));
    }

    Test::stop_for(Time::seconds(2));
    Test::stop_for(Time::seconds(4));

    Test::stop_for(Time::millis(5));
    fail_if_wakeup(Time::seconds(1));

    g_test_uart.tx_blocking(test_pass_text);

    TEST_SPIN();
}
